/************************************************
* CheckBrd - demonstrate fillpoly and the BitBLT*
* functions (draw a checkerboard, and randomly	*
* move a checker around on it).					*
************************************************/

#include <conio.h>
#include <dos.h>
#include <graphics.h>
#include <stdio.h>
#include <stdlib.h>

int GrafDev, GrafMode, GrafX, GrafY;
struct textsettingstype GrafTextSet;
int x, y;
char *chk;

int data[25][2];

void GrInit(void),		DrawBoard(void),
	 MakeChecker(void), MoveChecker(void);

void main(void)
	{
	GrInit();		/* Initialize graphics stuff*/
	MakeChecker();	/* Draw the checker			*/
	DrawBoard();	/* Draw the checkerboard	*/
	MoveChecker();	/* Move the checker around	*/
	closegraph();	/* Shut down graphics stuff	*/
	}

/************************************************
* GrInit - Initialize the graphics device, and	*
* find the size of it.							*
*												*
* INP:	-none-									*
* OUT:	-none-									*
* USES:	GrafDev - set to a value other graphics	*
*				  calls use.					*
*		GrafMode - set to the graphics mode		*
*		GrafX	- number of columns of pixels	*
*		GrafY	- number of rows of pixels		*
************************************************/

void GrInit(void)
	{
	GrafDev=DETECT;	/* Use autodetect for video	*/
	initgraph(&GrafDev,&GrafMode,"");
	if (graphresult()!=grOk)
		{
		puts("Graphics error\7");
		exit(1);
		}
	GrafX = getmaxx();
	GrafY = getmaxy();
	}


/************************************************
* MakeChecker - make a checker image			*
************************************************/
char fillpat[]={
	0x0f, 0xf0, 0x87, 0x78,
	0xc3, 0x3c, 0xe1, 0x1e
			   };
void MakeChecker(void)
	{
	cleardevice();
	setfillpattern(fillpat,2);
	x=GrafX/8; y=GrafY/8;
	fillellipse(x/2,y/2,(x-6)/2,(y-6)/2);
	chk=malloc(imagesize(2,2,x-2,y-2));
	getimage(2,2,x-2,y-2,chk);
	}

/************************************************
* DrawBoard - draw the checkerboard				*
************************************************/
double dBoardData[][2]=
	{
		{	0,		0	},	{	1/8.0,	0	},
		{	1/8.0,	1	},	{	2/8.0,	1	},
		{	2/8.0,	0	},	{	3/8.0,	0	},
		{	3/8.0,	1	},	{	4/8.0,	1	},
		{	4/8.0,	0	},	{   5/8.0,  0	},
		{	5/8.0,	1	},  {   6/8.0,  1	},
		{	6/8.0,	0	},  {   7/8.0,  0	},
		{	7/8.0,	1	},  {   1, 		1	},
		{	1,	7/8.0	},	{	0,	7/8.0	},
		{	0,	6/8.0	},	{	1,	6/8.0	},
		{	1,	5/8.0	},	{	0,	5/8.0	},
		{	0,	4/8.0	},	{	1,	4/8.0	},
		{	1,	3/8.0	},	{	0,	3/8.0	},
		{	0,	2/8.0	},	{	1,	2/8.0	},
		{	1,	1/8.0	},	{	0,	1/8.0	}
	};
int BoardData[31][2];
void DrawBoard(void)
	{
	int i;
	for (i=0; i<30; i++)
		{
		BoardData[i][0]=dBoardData[i][0]*GrafX;
		BoardData[i][1]=dBoardData[i][1]*GrafY;
		}
	setfillstyle(SOLID_FILL,1);
	fillpoly(30,BoardData);
	}

/************************************************
* MoveChecker - drop a checker, wait & pick up	*
************************************************/
void MoveChecker(void)
	{
	int tx, ty;

	while (1)
		{
		/* Quit if user has pressed a key */
		if (kbhit())
			{
			getch();
			return;
			}

		/* Choose a square */
		tx = rand()%8;
		ty = rand()%8;

		/* Draw the checker */
		putimage(tx*GrafX/8+2, ty*GrafY/8+2, chk,
			XOR_PUT);

		delay(1000);	/* Wait for one second	*/

		/* Erase the checker */
		putimage(tx*GrafX/8+2, ty*GrafY/8+2, chk,
			XOR_PUT);
		}
	}
