/************************************************
* example1.c - draw a line graph with the draw-	*
* poly function, then use floodfill on a closed	*
* figure, then floodfill an open figure.		*
*												*
* 900202 MCMason - originally written.			*
************************************************/

#include <conio.h>
#include <dos.h>
#include <graphics.h>
#include <stdio.h>
#include <stdlib.h>

int GrafDev, GrafMode, GrafX, GrafY;
struct textsettingstype GrafTextSet;
int data[25][2];
void BreakBorder(void),	DrawBorder(void),
	 DrawData(void),	DrawGrid(void),
	 FillRegion(void),	GrInit(void),
	 MakeData(void);

void main(void)
	{
	/*** Line Draw demonstration ***/
	GrInit();		/* Initialize graphics stuff*/
	DrawGrid();		/* Draw report grid			*/
	MakeData();		/* Generate report data		*/
	DrawData();		/* Draw data on screen		*/
	while (!kbhit())/* Wait for a keypress		*/
		;
	getch();
	/*** Floodfill demonstration ***/
	DrawBorder();	/* Draw the complex border	*/
	FillRegion();	/* Fill it in				*/
	while (!kbhit())/* Wait for a keypress		*/
		;
	getch();
	DrawBorder();	/* Draw border again		*/
	BreakBorder();	/* Put a hole in it			*/
	FillRegion();	/* Fill the region (screen)	*/
	while (!kbhit())/* Wait for a keypress		*/
		;
	getch();
	closegraph();	/* Shut down graphics stuff	*/
	}

/************************************************
* GrInit - Initialize the graphics device, and	*
* find the size of it.							*
*												*
* INP:	-none-									*
* OUT:	-none-									*
* USES:	GrafDev - set to a value other graphics	*
*				  calls use.					*
*		GrafMode - set to the graphics mode		*
*		GrafX	- number of columns of pixels	*
*		GrafY	- number of rows of pixels		*
************************************************/
void GrInit(void)
	{
	GrafDev=DETECT;	/* Use autodetect for video	*/
	initgraph(&GrafDev,&GrafMode,"");
	if (graphresult()!=grOk)
		{
		puts("Graphics error\7");
		exit(1);
		}
	GrafX = getmaxx();
	GrafY = getmaxy();
	}

/************************************************
* DrawGrid - draw a grid to hold the data		*
************************************************/
void DrawGrid(void)
	{
	cleardevice();
	gettextsettings(&GrafTextSet);
	outtextxy(  (GrafX-GrafTextSet.horiz)/2,
				GrafTextSet.vert,
				"Data Chart");
	setcolor(1);
	line(0,0,0,GrafY);
	line(0,GrafY,GrafX,GrafY);
	}

/************************************************
* MakeData - make some random data for chart	*
*												*
* USES:	data - the array to randomly fill		*
************************************************/
void MakeData(void)
	{
	int i;
	for (i=0; i<25; i++)
		{
		data[i][0]=(i*GrafX)/25;
		data[i][1]=rand()%GrafY;
		}
	}

/************************************************
* DrawData - draw the data in the chart			*
************************************************/
void DrawData(void)
	{
	setcolor(2);
	drawpoly(25,data);
	}

/************************************************
* DrawBorder - draw a complex border			*
************************************************/
void DrawBorder(void)
	{
	cleardevice();
	ellipse(GrafX/2,GrafY/2,180,360,GrafX/6,
			GrafY/6);
	ellipse(3*GrafX/4,GrafY/2,0,180,GrafX/12,
			GrafY/12);
	ellipse(GrafX/4,GrafY/2,0,180,GrafX/12,
			GrafY/12);
	ellipse(GrafX/2,GrafY/2,180,360,GrafX/3,
			GrafY/3);
	}

/************************************************
* FillRegion - seed point at left 'peak'		*
************************************************/
void FillRegion(void)
	{
	setfillstyle(INTERLEAVE_FILL,1);
	floodfill(3*GrafX/4,GrafY/2,getcolor());
	}

/************************************************
* BreakBorder - put two 1-pixel holes in border	*
************************************************/
void BreakBorder(void)
	{
	int i;
	i=getcolor();			/* Save drawing colr*/
	setcolor(getbkcolor());	/* Set 'erase' colr	*/
	line(0,0,GrafX,GrafY);	/* Make two holes	*/
	setcolor(i);			/* Restore draw colr*/
	}
