/* moudemo.c - demonstrate the TCMOU routines
 *
 * Richard Hale Shaw
 */
#include"tcmou.h"
#include<stdlib.h>
#include<stdio.h>
#include<stdarg.h>
#include<string.h>
#include<conio.h>
#include<dos.h>
#include<graphics.h>

#define ROWROW          6
#define COLROW          7
#define BU1DISPLAYROW   8
#define BU2DISPLAYROW   9
#define BU3DISPLAYROW   10
#define EXITROW         12
#define MSGCOL          9
#define VARCOL          31
#define FONT_DIMEN      8
#define CURSOR_OFF      0
#define CURSOR_ON       1

int graphics=FALSE;
void cdecl atsay(unsigned row, unsigned col,
        char *fmt, ...);

void main(void)
    {
    char *startmsg = "Mouse pointer should "
        "initially appear here:";
    char *down = "DOWN", *up = "UP  ";
    unsigned prow,pcol,buttonval,numbuttons;
    int graphdriver = DETECT,graphmode,
        exiting = FALSE;

    if(!MouOpen())
        {
        printf("Unable to initiatize mouse:\n"
            "make sure mouse driver is loaded "
            "and mouse installed\n");
        exit(0);
        }
    clrscr();

    while(!exiting)
        {
        atsay(0,0,"Click left and right mouse "
            "buttons simultaneously to switch "
            "screen modes...");
        MouDrawPtr();
        numbuttons = MouNumButtons();
        atsay(4,9,startmsg);
        atsay(ROWROW,MSGCOL,
            "Mouse Pointer at row:");
        atsay(COLROW,MSGCOL,
            "Mouse Pointer at col:");
        atsay(BU1DISPLAYROW,MSGCOL,
            "Mouse Button 1 is:");
        if(numbuttons > 1)
            atsay(BU2DISPLAYROW,MSGCOL,
                "Mouse Button 2 is:");
        if(numbuttons > 2)
            atsay(BU3DISPLAYROW,MSGCOL,
                "Mouse Button 3 is:");

        atsay(EXITROW,MSGCOL,
            "Click Mouse here X to terminate "
            "program.");

        MouSetPtrPos(MouVPos(4),
            MouVPos((MSGCOL+strlen(startmsg))));

        while(TRUE)
            {
            MouCharIn(&prow,&pcol,
                &buttonval);
            atsay(ROWROW,VARCOL,
                "%03u (pixel %03u)",
                MouCharPos(prow),prow);
            atsay(COLROW,VARCOL,
                "%03u (pixel %03u)",
                MouCharPos(pcol),pcol);
            atsay(BU1DISPLAYROW,VARCOL,
                (LeftMouButton(buttonval) ?
                down : up));
            if(numbuttons > 1)
                atsay(BU2DISPLAYROW,VARCOL,
                    (RightMouButton(buttonval)
                    ? down : up));
            if(numbuttons > 2)
                atsay(BU3DISPLAYROW,VARCOL,
                    (CenterMouButton(buttonval)
                    ? down : up));

                /* if Left and Right buttons
                   pressed, switch modes
                 */
            if(LRMouButtons(buttonval))
                break;
                /* if Left button clicked on
                   'X', get out
                 */
            if(LeftMouButton(buttonval) &&
                (MouCharPos(prow) == EXITROW) &&
                (MouCharPos(pcol) == (MSGCOL+17)))
                {
                exiting = TRUE;
                break;
                }
            }
        if(exiting)
            {
            if(graphics)
                closegraph();
            break;
            }

        MouRemovePtr();
        if(!graphics)
            {
            initgraph(&graphdriver,
                    &graphmode,"");
            if(graphdriver < 0)
                {
                clrscr();
                printf("error %d: %s\n",
                    graphdriver,
                    grapherrormsg(graphdriver));
                MouClose();
                exit(graphdriver);
                }
            graphics = TRUE;
            settextstyle(DEFAULT_FONT,
                HORIZ_DIR,1);
            setfillstyle(EMPTY_FILL,BLACK);
            setcolor(WHITE);
            setbkcolor(BLACK);
            }
        else
            {
            closegraph();
            graphics = FALSE;
            }
        }
    MouRemovePtr();
    if(!MouClose())
        printf("Unable to close mouse\n");
    clrscr();
    }

void cdecl atsay(unsigned row, unsigned col,
    char *fmt, ...)
    {
    char workbuffer[250];
    va_list argptr;
    unsigned grow,gcol;

    va_start(argptr,fmt);
    vsprintf(workbuffer,fmt,argptr);
    va_end(arg_ptr);
    if(!graphics)
        {
        gotoxy(col+1,row+1);
        puts(workbuffer);
		}
    else
        {
        grow = row*FONT_DIMEN;
        gcol = col*FONT_DIMEN;
        bar(gcol,grow,gcol+textwidth(workbuffer),
            grow+textheight(workbuffer));
        outtextxy(gcol,grow,workbuffer);
        }
    }
