/************************************************
* QUEENS - solve the classical 'Queens' problem	*
* for a board of size n.  The problem is to	put	*
* N queens (chess pieces) on an N x N board so	*
* that no queen can attack any of the others.	*
* This implementation will print the number of	*
* solutions found for each board size, from 1	*
* to 9 squares on a side.						*
*												*
* 900125 MCMason - originally coded				*
************************************************/

#include <stdio.h>

#define MAXBRD 25		/* Maximum board size	*/

int		board[MAXBRD+1][MAXBRD+1];	/* Chess brd*/
long	TotalSolns=0,	/* Total solns/all sizes*/
		Solns=0;		/* Solutions per size	*/

void queens(int, int);	/* F(n) to solve puzzle	*/

void main(void)
	{
	int i,j,k;

	/* Print table heading */
	puts("# Queens    # solns    Total #");
	puts("# Brd sz    this sz     solns");
	puts("--------    -------    -------");

	/* Find the number of solutions for each	*/
	/* board size, and print the table entry.	*/
	for (TotalSolns=0,i=1; i<10; i++)
		{

		/* Clear the board */
		for (j=0; j<i; j++)
			for (k=0; k<i; k++)
				board[j][k]=0;

		/* Solve the problem */
		Solns = 0;
		queens(0,i);		/* Start @ column 0	*/

		/* Print current summary */
		TotalSolns += Solns;
		printf("   %2d         %3ld       %4ld\n",
				   i,          Solns, TotalSolns);
		}

	/* Print end of table footer */
	puts("--------    -------    -------");
	}
